import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { Match, MatchParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询比赛信息表
 */
export async function pageMatch(params: MatchParam) {
  const res = await request.get<ApiResult<PageResult<Match>>>(
    MODULES_API_URL + '/booking/match/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询比赛信息表列表
 */
export async function listMatch(params?: MatchParam) {
  const res = await request.get<ApiResult<Match[]>>(
    MODULES_API_URL + '/booking/match',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加比赛信息表
 */
export async function addMatch(data: Match) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/match',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改比赛信息表
 */
export async function updateMatch(data: Match) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/match',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除比赛信息表
 */
export async function removeMatch(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/match/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除比赛信息表
 */
export async function removeBatchMatch(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/match/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询比赛信息表
 */
export async function getMatch(id: number) {
  const res = await request.get<ApiResult<Match>>(
    MODULES_API_URL + '/booking/match/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
